subroutine change_working_dir()

! This routine gets the first argument of the commandline and takes it
! as the path to change the working directory
! used intrinsic routines:
! iarg returns the number of commandline arguments without the program cname.
! chdir changes the directory and returns 0 on success.
! trim removes blanks from strings.

  character (len = 256) :: argument
  integer :: status

  if (iargc() == 1) then
    call getarg(1, argument)
    status = chdir(trim(argument))
    if (status /= 0) then
      write (*,*) '*** change directory failed ***'
      write (*,*) 'directory tried: ', trim(argument)
      write (*,*) 'error code (see: man chdir): ', status
      write (*,*) 'continuing in the start directory'
    end if
  end if

  return
end subroutine change_working_dir
