!***********************************************************************************************************************************
program getopt_example
  use sufr_getopt, only: getopt_t, getopt, optarg, getopt_help
  implicit none
  character :: option, optStr*(99)
  
  ! Set the option string for short options.  Only specify the character after the dash (e.g. 'a' for -a).  Characters followed
  !   by a colon (:) have a required argument:
  optstr = 'af:hx'
  
  do  ! scan all the command-line parameters
 
     ! getopt() returns a single character" ">","!",".", or the short-option character (e.g. "a" for -a).
     !   It also sets this 'global' variable through the SUFR_getopt module:
     !   - optArg:      the argument following the option (if required and present)
     option = getopt(trim(optstr))
     
     ! Do different things depending on the option returned:
     select case(option)
     case('>')  ! Last parameter
        if(command_argument_count().eq.0) call getopt_help(trim(optstr))  ! No parameters found - print help
        exit
     case('!')  ! Unknown option (starting with "-" or "--")
        write(*,'(A)') 'WARNING: unknown option:  '//trim(optarg)//'  Use -h for a list of valid options'
     case('a')
        write(*,'(A)') 'Found option:             -'//option
     case('f')
        write(*,'(A)') 'Found option:             -'//option//' '//trim(optarg)
     case('h')
        call getopt_help(trim(optstr))
     case('.')  ! Parameter is not an option (i.e., it doesn't start with "-" or "--")
        write(*,'(A)') 'Found non-option element: '//trim(optarg)
     case default
        write(*,'(A)') 'Option ignored:           -'//option
     end select
  end do
  
end program getopt_example
!***********************************************************************************************************************************
